#!/bin/bash

function dump
{

echo -e " = `hda-verb $1 $2 $3 | tail -c 3`"
}

function dump_DAC1
{
dump 0x2 $1 $2
}
function dump_DAC2
{
dump 0x3 $1 $2
}
function dump_DAC3
{
dump 0x4 $1 $2
}

echo
echo -e "HDA Stream:"
printf "\tDAC 1     "
dump_DAC1 0xf06  0x0
printf "\tDAC 2     "
dump_DAC2 0xf06  0x0
printf "\tDAC 3     "
dump_DAC3 0xf06  0x0

function dump_PIN1
{
dump 0xb $1 $2
}
function dump_PIN2
{
dump 0x10 $1 $2
}
function dump_PIN3
{
dump 0x11 $1 $2
}

function dump_PIN4
{
dump 0xf $1 $2
}

echo
echo -e "Pin Widget Control:"
printf "\tSpeakers  "
dump_PIN1 0xf07  0x0
printf "\tCenter/Sub"
dump_PIN2 0xf07  0x0
printf "\tRears     "
dump_PIN3 0xf07  0x0
printf "\tHeadphones"
dump_PIN4 0xf07  0x0


function dump_1
{
	dump 0x1 $1 $2
}

function dump_15
{
    dump 0x15 $1 $2
}

echo

echo -e "GPIO:"

printf "\tFind GPIOs"
dump_1 0xf90 0x0

printf "\tDirection "
dump_1 0xf17 0x0

printf "\tEnable    "
dump_1 0xf16 0x0

printf "\tData      "
dump_1 0xf15 0x0

echo
echo -e "Extensions:"
printf "\tStatus    "
dump_15 0xf0a 0x0

printf "\tlatest ID "
dump_15 0xf17 0x00

printf "\tlast Value"
dump_15 0xf18 0x00

printf "\tParam 0xD "
dump_15 0xf10 0x0d

function dump
{
echo -e "= `hda-verb $1 $2 $3 | tail -c 9`"
}

function dump_15
{
dump 0x15 $1 $2
}
echo
echo -e "Flags:"
printf "\tValue "
dump_15 0xf0f  0x0

echo
